var Player =
{
    plugin : null,
    state : -1,
    skipState : -1,
    stopCallback : null,    /* Callback function to be set by client */
    originalSource : null,
    
    buffer: 1,
    
    current_time : 0,
    
    STOPPED : 0,
    PLAYING : 1,
    PAUSED : 2,  
    FORWARD : 3,
    REWIND : 4
}

var intervalID;

Player.init = function()
{

  intervalID = setInterval(function(){cyclicInternetConnectionCheck()},internetConnectionInterval);


    var success = true;
    alert("success vale :  " + success);    
    this.state = this.STOPPED;
    
    this.plugin = document.getElementById("pluginPlayer");

    this.plugin.OnNetworkDisconnected = 'Player.OnNetworkDisconnected';
    this.plugin.OnConnectionFailed = 'Player.onConnectionFailed';
    this.plugin.OnRenderError = 'Player.onRenderError';
    this.plugin.OnStreamNotFound = 'Player.onStreamNotFound';
    this.plugin.onServerError = 'Player.onServerError';
    this.plugin.OnAuthenticationFailed = 'Player.AuthenticationFailed';
    this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
    this.plugin.OnStreamInfoReady = 'Player.setTotalTime';
    this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';   

    if (!this.plugin) {
      alert("success vale this.plugin :  " + success);    
      success = false;
    }
    this.setWindow();
    alert("success vale :  " + success);       
    return success;
}

Player.deinit = function()
{
  clearInterval(intervalID);

      alert("Player deinit !!! " );       
      if (this.plugin)
      {
            this.plugin.Stop();
      }
}

Player.setWindow = function()
{
  this.plugin.SetDisplayArea(90, 60, 480, 270);
}

Player.setFullscreen = function()
{
  this.plugin.SetDisplayArea(0, 0, 960, 540);
}

Player.setVideoURL = function(url)
{
    this.url = url;
    alert("URL = " + this.url);
}

Player.playVideo = function() {
  if (this.url == null) {
    alert("No videos to play");
  } else {
    this.buffer = 0;
    $("#loading").show();
    pluginAPI.setOffScreenSaver();
    this.state = this.PLAYING;
    Display.status("Play");
    this.setWindow();
    this.plugin.Play( this.url );
    Audio.plugin.SetUserMute(0);
  }
}

Player.pauseVideo = function() {
  pluginAPI.setOnScreenSaver(1200);
  this.state = this.PAUSED;
  Display.status("Pause");
  this.plugin.Pause();
}

Player.stopVideo = function() {
  if (this.state != this.STOPPED) {
    pluginAPI.setOnScreenSaver(1200);
    this.state = this.STOPPED;
    Display.status("Stop");
    this.plugin.Stop();
    Display.setTime(0);
        
    if (this.stopCallback)  {
      this.stopCallback();
    }
  } else {
    alert("Ignoring stop request, not in correct state");
  }
}

Player.resumeVideo = function()
{
    pluginAPI.setOffScreenSaver();
    this.state = this.PLAYING;
    Display.status("Play");
    this.plugin.Resume();
}

Player.skipForwardVideo = function(s)
{
    this.skipState = this.FORWARD;
    this.plugin.JumpForward(s);
    Display.setTime(this.current_time);

}

Player.skipBackwardVideo = function(s)
{
    this.skipState = this.REWIND;
    this.plugin.JumpBackward(s);
}

Player.getState = function()
{
    return this.state;
}

Player.getBufferState = function()
{
  return this.buffer;
}


Player.onBufferingStart = function()
{
    this.buffer = 0;
    Display.status("Buffering...");
    switch(this.skipState)
    {
        case this.FORWARD:
            //document.getElementById("forward").style.opacity = '0.2';
            break;
        
        case this.REWIND:
            //document.getElementById("rewind").style.opacity = '0.2';
            break;
    }
}

Player.onBufferingProgress = function(percent)  {
  this.buffer = 0;
  Display.status("Buffering:" + percent + "%");
}

Player.onBufferingComplete = function() {
  this.buffer = 1;
  $("#loading").hide();
  Display.status("Play!");

  switch(this.skipState) {
    case this.FORWARD:
    //document.getElementById("forward").style.opacity = '1.0';
    break;    
    case this.REWIND:
    //document.getElementById("rewind").style.opacity = '1.0';
    break;
    }
}

Player.setCurTime = function(time)
{
    Display.setTime(time);
    this.current_time = time;
}

Player.setTotalTime = function()
{
    Display.setTotalTime(Player.plugin.GetDuration());
}

Player.onServerError = function()
{
    Display.popup("<span>Ошибка сервера!</span>");
}

Player.AuthenticationFailed = function()
{
    Display.popup("<span>Ошибка авторизации!</span>");
}

Player.OnNetworkDisconnected = function()
{
  Display.popup("<span>Ошибка сети!</span>");
  Player.stopVideo();
}

Player.onConnectionFailed = function()
{
  Display.popup("<span>Ошибка соединения!</span>");
  Player.stopVideo();
}

Player.onStreamNotFound = function()
{
  Display.popup("<span>Поток не найден!</span>");
  Player.stopVideo();
}

getBandwidth = function(bandwidth) { alert("getBandwidth " + bandwidth); }

onDecoderReady = function() { alert("onDecoderReady"); }

Player.onRenderError = function() {
  Player.stopVideo();
  alert("Render Error!");
}

stopPlayer = function()
{
    Player.stopVideo();
}

setTottalBuffer = function(buffer) { alert("setTottalBuffer " + buffer); }

setCurBuffer = function(buffer) { alert("setCurBuffer " + buffer); }
